%% Simulate experiment and generate data
clear all
close all
clc

% Some administration
dt  = 0.01;                 % Sample time
T   = 50;                   % Total time
N   = T/dt;                 % number of samples
t   = (0:N-1).'*dt;         % Time vector

Fs  = 1./dt;                % Sample frequency
f   = (0:N-1).'/T;          % Frequency vector (double sided)

% Simulate model
options=simset('OutputPoints','specified'); % only produce output for the time values in vector <t>
sim('SISO_closed_loop',t,options)
clear tout

% Plot input and output
figure
subplot(411), plot(t,u)
ylabel('input u')
title ('Input and output signals')
subplot(412), plot(t,y)
ylabel('output y')
subplot(413), plot(t,u)
ylabel('signal u')
subplot(414), plot(t,w)
ylabel('signal w')
xlabel('time [s]')

%% Determine Fourier transforms and spectral densities
% Fourier transforms

% Spectral densities


%% Estimate transfer function and coherence
% Closed loop transfer function H2
% Insert your own estimates here!!!

Hcl_1 = [];     % First method: use u(t) for estimating H2
Hcl_2 = [];     % Second method: use w(t) for estimating H2

% Squared coherence Cohyr function between r and y
Cohuy = [];
Cohwy = [];

%% Apply frequency averaging and estimate transfer function

%% Apply averaging over segments (Welch) and estimate transfer function

%% Determine true system transfer function
% Make transfer function H2
num = 5;
den = [0.025 0.15 1];
tf2true = tf(num, den);

% Determine transfer function values for each value in frequency vector f.
H2true = squeeze(freqresp(tf2true, 2*pi*f));

%% Plot results of estimates and coherence
